#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,ADD10_OUT)
  __DECLARE_VAR(BOOL,EQ13_OUT)
  __DECLARE_VAR(UINT,SEL15_OUT)
  __DECLARE_VAR(BOOL,AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// FUNCTION_BLOCK W_TO_B_ON
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(WORD,IN0)
  __DECLARE_VAR(BOOL,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,VAL_COMP)
  __DECLARE_VAR(BOOL,VAL0)
  __DECLARE_VAR(BOOL,OUT0)
  __DECLARE_VAR(BOOL,OUT1)

} W_TO_B_ON;

void W_TO_B_ON_init__(W_TO_B_ON *data__, BOOL retain);
// Code part
void W_TO_B_ON_body__(W_TO_B_ON *data__);
// FUNCTION_BLOCK B_TO_W_ON
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN0)
  __DECLARE_VAR(WORD,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,VAL0)
  __DECLARE_VAR(WORD,OUT0)
  __DECLARE_VAR(WORD,OUT1)

} B_TO_W_ON;

void B_TO_W_ON_init__(B_TO_W_ON *data__, BOOL retain);
// Code part
void B_TO_W_ON_body__(B_TO_W_ON *data__);
// PROGRAM UNO_CONVEYOR
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,OUT_3)
  __DECLARE_VAR(WORD,OUT_5)
  __DECLARE_VAR(BOOL,OUT_4)
  __DECLARE_VAR(BOOL,OUT_8)
  __DECLARE_VAR(WORD,INP_A4)
  __DECLARE_VAR(WORD,INP_A5)
  W_TO_B_ON W_TO_B_ON5;
  TOF TOF0;
  F_TRIG F_TRIG0;
  B_TO_W_ON B_TO_W_ON0;
  TOF TOF1;
  F_TRIG F_TRIG1;
  B_TO_W_ON B_TO_W_ON1;
  W_TO_B_ON W_TO_B_ON6;
  __DECLARE_VAR(WORD,OR111_OUT)
  __DECLARE_VAR(WORD,NOT4_OUT)
  __DECLARE_VAR(BOOL,WORD_TO_BOOL105_OUT)

} UNO_CONVEYOR;

void UNO_CONVEYOR_init__(UNO_CONVEYOR *data__, BOOL retain);
// Code part
void UNO_CONVEYOR_body__(UNO_CONVEYOR *data__);
// FUNCTION_BLOCK W_TO_B_OFF
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(WORD,IN0)
  __DECLARE_VAR(BOOL,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,VAL_COMP)
  __DECLARE_VAR(BOOL,VAL0)
  __DECLARE_VAR(BOOL,OUT0)
  __DECLARE_VAR(BOOL,OUT1)

} W_TO_B_OFF;

void W_TO_B_OFF_init__(W_TO_B_OFF *data__, BOOL retain);
// Code part
void W_TO_B_OFF_body__(W_TO_B_OFF *data__);
#endif //__POUS_H
